# std::bitset< _Nb > Class Template Reference
[Containers]

Inheritance diagram for std::bitset< _Nb >:

List of all members.

## Detailed Description

### template<size_t _Nb>
class std::bitset< _Nb >

(Note that bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, Nb, may be any non-negative number, specifying the number of bits (e.g., "0", "12", "1024*1024").

In the general unoptimized case, storage is allocated in word-sized blocks. Let B be the number of bits in a word, then (Nb+(B-1))/B words will be used for storage. B - NbB bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of bitset as "a simple array of bits," be aware that your mental picture is reversed: a bitset behaves the same way as bits in integers do, with the bit at index 0 in the "least significant / right-hand" position, and the bit at index Nb-1 in the "most significant / left-hand" position. Thus, unlike other containers, a bitset's index "counts from right to left," to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints "b('a') is 0001100001" on a modern ASCII system.

         #include <bitset>
         #include <iostream>
         #include <sstream>

         using namespace std;

         int main()
         {
             long         a = 'a';
             bitset<10>   b(a);

             cout << "b('a') is " << b << endl;

             ostringstream s;
             s << b;
             string  str = s.str();
             cout << "index 3 in the string is " << str[3] << " but\n"
                  << "index 3 in the bitset is " << b[3] << endl;
         }

Also see http://gcc.gnu.org/onlinedocs/libstdc++/ext/sgiexts.html#ch23 for a description of extensions.

Definition at line 646 of file bitset.

## Public Member Functions

- size_t _Find_first () const
- size_t _Find_next (size_t __prev) const
- template<class _CharT, class _Traits, class _Alloc> void _M_copy_from_string (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t, size_t)
- template<class _CharT, class _Traits, class _Alloc> void _M_copy_to_string (std::basic_string< _CharT, _Traits, _Alloc > &) const
- bool any () const
- template<class _CharT, class _Traits, class _Alloc> bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n)
- template<class _CharT, class _Traits, class _Alloc> bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position=0)
- bitset (unsigned long __val)
- bitset ()
- size_t count () const
- bitset< _Nb > & flip (size_t __position)
- bitset< _Nb > & flip ()
- bool none () const
- bitset< _Nb > operator~ () const
- bitset< _Nb > & reset (size_t __position)
- bitset< _Nb > & reset ()
- bitset< _Nb > & set (size_t __position, bool __val=true)
- bitset< _Nb > & set ()
- size_t size () const
- bool test (size_t __position) const
- std::basic_string< char, std::char_traits<
  char >, std::allocator< char > > to_string () const
- template<class _CharT> std::basic_string< _CharT,
  std::char_traits< _CharT >,
  std::allocator< _CharT > > to_string () const
- template<class _CharT, class _Traits> std::basic_string< _CharT,
  _Traits, std::allocator<
  _CharT > > to_string () const
- template<class _CharT, class _Traits, class _Alloc> std::basic_string< _CharT,
  _Traits, _Alloc > to_string () const
- unsigned long to_ulong () const

- bitset< _Nb > & _Unchecked_flip (size_t __pos)
- bitset< _Nb > & _Unchecked_reset (size_t __pos)
- bitset< _Nb > & _Unchecked_set (size_t __pos, int __val)
- bitset< _Nb > & _Unchecked_set (size_t __pos)
- bool _Unchecked_test (size_t __pos) const

- template<> bitset< 0 > & flip (size_t)
- template<> bitset< 0 > & reset (size_t)
- template<> bitset< 0 > & set (size_t, bool)
- template<> bool test (size_t) const

- bitset< _Nb > & operator &= (const bitset< _Nb > &__rhs)
- bitset< _Nb > & operator^= (const bitset< _Nb > &__rhs)
- bitset< _Nb > & operator|= (const bitset< _Nb > &__rhs)

- bool operator!= (const bitset< _Nb > &__rhs) const
- bool operator== (const bitset< _Nb > &__rhs) const

- bitset< _Nb > operator<< (size_t __position) const
- bitset< _Nb > operator>> (size_t __position) const

- bitset< _Nb > & operator<<= (size_t __position)
- bitset< _Nb > & operator>>= (size_t __position)

- bool operator[] (size_t __position) const
- reference operator[] (size_t __position)

## Friends

- class reference

## Classes

- class reference

## Constructor & Destructor Documentation

template<size_t _Nb>

std::bitset< _Nb >::bitset | ( |  | ) | `[inline]`

All bits set to zero.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 736 of file bitset.

template<size_t _Nb>

std::bitset< _Nb >::bitset | ( | unsigned long | __val | ) | `[inline]`

Initial bits bitwise-copied from a single word (others set to zero).

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 740 of file bitset.

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>

std::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position = `0` |
| ) |  |  | `[inline, explicit]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use; defaults to zero.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 755 of file bitset.

References __N, std::bitset< _Nb >::_M_copy_from_string(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>

std::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position,
|  | size_t | __n |
| ) |  |  | `[inline]`

Use a subset of a string.

Parameters:

  | s | A string of '0' and '1' characters.
  | position | Index of the first character in s to use.
  | n | The number of characters to copy.

Exceptions:

  | std::out_of_range | If pos is bigger the size of s.
  | std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 776 of file bitset.

References __N, std::bitset< _Nb >::_M_copy_from_string(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

## Member Function Documentation

template<size_t _Nb>

bool std::bitset< _Nb >::any | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if at least one bit is set.

Definition at line 1100 of file bitset.

References std::_Base_bitset< _Nw >::_M_is_any().

template<size_t _Nb>

size_t std::bitset< _Nb >::count | ( |  | ) | const`[inline]`

Returns the number of bits which are set.

Definition at line 1062 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_count().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::flip | ( | size_t | __position | ) | `[inline]`

Toggles a given bit to its opposite value.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 961 of file bitset.

References __N, and std::bitset< _Nb >::_Unchecked_flip().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::flip | ( |  | ) | `[inline]`

Toggles every bit to its opposite value.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 948 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_flip().

Referenced by std::__debug::bitset< _Nb >::flip().

template<size_t _Nb>

bool std::bitset< _Nb >::none | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if none of the bits are set.

Definition at line 1108 of file bitset.

References std::_Base_bitset< _Nw >::_M_is_any().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::operator &= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 795 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_and().

template<size_t _Nb>

bitset<_Nb> std::bitset< _Nb >::operator<< | ( | size_t | __position | ) | const`[inline]`

Self-explanatory.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 1114 of file bitset.

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::operator<<= | ( | size_t | __position | ) | `[inline]`

Operations on bitsets.

Parameters:

  | position | The number of places to shift.

These should be self-explanatory.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 824 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_left_shift(), and std::_Base_bitset< _Nw >::_M_do_reset().

template<size_t _Nb>

bool std::bitset< _Nb >::operator== | ( | const bitset< _Nb > & | __rhs | ) | const`[inline]`

These comparisons for equality/inequality are, well, bitwise.

Definition at line 1073 of file bitset.

References std::_Base_bitset< _Nw >::_M_is_equal().

template<size_t _Nb>

bitset<_Nb> std::bitset< _Nb >::operator>> | ( | size_t | __position | ) | const`[inline]`

Self-explanatory.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 1118 of file bitset.

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::operator>>= | ( | size_t | __position | ) | `[inline]`

Operations on bitsets.

Parameters:

  | position | The number of places to shift.

These should be self-explanatory.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 837 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_reset(), and std::_Base_bitset< _Nw >::_M_do_right_shift().

template<size_t _Nb>

reference std::bitset< _Nb >::operator[] | ( | size_t | __position | ) | `[inline]`

Array-indexing support.

Parameters:

  | position | Index into the bitset.

Returns:
  A bool for a 'const bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 991 of file bitset.

References std::bitset< _Nb >::reference.

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::operator^= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 809 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_xor().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::operator|= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  | rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 802 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_or().

template<size_t _Nb>

bitset<_Nb> std::bitset< _Nb >::operator~ | ( |  | ) | const`[inline]`

See the no-argument flip().

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 970 of file bitset.

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::reset | ( | size_t | __position | ) | `[inline]`

Sets a given bit to false.

Parameters:

  | position | The index of the bit.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Same as writing `set(pos,false)`.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 937 of file bitset.

References __N, and std::bitset< _Nb >::_Unchecked_reset().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::reset | ( |  | ) | `[inline]`

Sets every bit to false.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 923 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_reset().

Referenced by std::bitset< _Nb >::_M_copy_from_string(), and std::__debug::bitset< _Nb >::reset().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::set | ( | size_t | __position,
|  | bool | __val = `true` |
| ) |  |  | `[inline]`

Sets a given bit to a particular value.

Parameters:

  | position | The index of the bit.
  | val | Either true or false, defaults to true.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 912 of file bitset.

References __N, and std::bitset< _Nb >::_Unchecked_set().

template<size_t _Nb>

bitset<_Nb>& std::bitset< _Nb >::set | ( |  | ) | `[inline]`

Sets every bit to true.

Reimplemented in std::__debug::bitset< _Nb >.

Definition at line 898 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_set().

Referenced by std::__debug::bitset< _Nb >::set().

template<size_t _Nb>

size_t std::bitset< _Nb >::size | ( |  | ) | const`[inline]`

Returns the total number of bits.

Definition at line 1067 of file bitset.

template<size_t _Nb>

bool std::bitset< _Nb >::test | ( | size_t | __position | ) | const`[inline]`

Tests the value of a bit.

Parameters:

  | position | The index of a bit.

Returns:
  The value at pos.

Exceptions:

  | std::out_of_range | If pos is bigger the size of the set.

Definition at line 1088 of file bitset.

References __N, and std::bitset< _Nb >::_Unchecked_test().

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>

std::basic_string<_CharT, _Traits, _Alloc> std::bitset< _Nb >::to_string | ( |  | ) | const`[inline]`

Retuns a character interpretation of the bitset.

Returns:
  The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Reimplemented in std::__debug::bitset< _Nb >, std::__debug::bitset< _Nb >, std::__debug::bitset< _Nb >, and std::__debug::bitset< _Nb >.

Definition at line 1019 of file bitset.

References std::bitset< _Nb >::_M_copy_to_string().

template<size_t _Nb>

unsigned long std::bitset< _Nb >::to_ulong | ( |  | ) | const`[inline]`

Retuns a numerical interpretation of the bitset.

Returns:
  The integral equivalent of the bits.

Exceptions:

  | std::overflow_error | If there are too many bits to be represented in an `unsigned` `long`.

Definition at line 1006 of file bitset.

References std::_Base_bitset< _Nw >::_M_do_to_ulong().

The documentation for this class was generated from the following file:

- bitset